program Chess;

{
   Copyleft Message from your Sponsor:

        This program is utterly copyright (c) David Bennett, 1990
        and WhelkSoft, his 'software label', also 1990.
        Except for the bits that are copyright Borland Software.
        The actual code is distributed according to a vaguely
        Free Software Foundation license.  That is:

        You can copy the source and binaries.  You can distribute
        them to everyone you know.  However:

        1. You MAY NOT charge for the program, except for a reasonable
        cost of media and transportation.

        2. The original program was written by David Bennett and
        original authorship still resides with him.  So, you must
        distribute code still having his copyright messages.

        3. We strongly recommend that any site having or using this
        software should have the original sourcecode available to
        anyone who wants it.  Further development of computing in
        general may depend on sharing expertise and code.

        4. The above conditions should apply to any further
        development of this program.

        Please send the University Computer Club (oh, and David
        Bennett) some sort of postcard from where you are and how
        much you hate Whelk Chess ... we like to have our egos stroked!

}
{ This program was modified from the original Reversi program.
  Started 1/10/1990 }

uses
  crt,
  fossil,
  fosout,
  chessmov,
  chestype,
  chesutil, { board displaying routines, + other utils }
  chessbash, { Sysop Bashing of games routines I lost these routines,

      so I am sorry but they are not included at the moment. OK.}
  readinfo;

procedure InitBoard(var b:board);
  var
    i,j:integer;
begin
  for i := 1 to 8 do
    for j := 1 to 8 do
      b[i,j]:='  ';
  for i:= 1 to 8 do
    begin
    b[i,2]:='WP1';
    b[i,7]:='BP1';
    end;
  b[1,1]:='WR1';
  b[2,1]:='WN1';
  b[3,1]:='WB1';
  b[4,1]:='WQ1';
  b[5,1]:='WK1';
  b[6,1]:='WB1';
  b[7,1]:='WN1';
  b[8,1]:='WR1';
  b[1,8]:='BR1';
  b[2,8]:='BN1';
  b[3,8]:='BB1';
  b[4,8]:='BQ1';
  b[5,8]:='BK1';
  b[6,8]:='BB1';
  b[7,8]:='BN1';
  b[8,8]:='BR1';
end; { of proc initboard }

function ReadMove(      b:board;
                  var x,y,
                    x2,y2:integer;
                       me:char;
                    l1,l2:string):boolean;
  var s:string;
      finished,
      retval,
      allnum,
      allnum2,
      allchar2,
      allchar:boolean;
      c:char;
      i,j:integer;
begin
  finished := false;
  allnum   := false;
  allchar  := false;
  allnum2  := false;
  allchar2 := false;
  s:='';
  repeat
    c:=inkey;
    case ord(c) of
      27 : begin
           finished:=true;
           Retval:=false;
           end;
       8 : begin
           if allnum and allchar and (not allnum2) and (not allchar2) then
             writestr(chr(8)+' '+chr(8));
           if (s[length(s)] in ['0'..'9']) then
             if allnum2 then
               allnum2:=false
             else
               allnum:=false;
           if (s[length(s)] in ['A'..'H']) then
             if allchar2 then
               allchar2:=false
             else
               allchar:=false;
           if length(s)<>0 then
             begin
             s:=copy(s,1,length(s)-1);
             writestr(chr(8)+' '+chr(8));
             end;
           end; { backspace }
      48..57 :
           begin
           if not allnum then
             begin
             s:=s+c;
             writestr(c);
             allnum:=true;
             if allchar then
               writestr('-');
             end
           else
             if allchar and (not allnum2) then
               begin
               s:=s+c;
               writestr(c);
               allnum2:=true;
               end;
           end;
      13 : begin
           finished := true;
           Retval := true;
           end;
       65..72,
       97..104 :
          begin
          if not allchar then
            begin
            s:=s+upcase(c);
            writestr(upcase(c));
            allchar := true;
            if allnum then
              writestr('-');
            end
          else
            if allnum and (not allchar2) then
              begin
              s:=s+upcase(c);
              writestr(upcase(c));
              allchar2:=true;
              end;
          end;
    end; { of case }
  until finished;
  if (length(s)<>4) then
    begin
    x:=1;
    y:=1;
    while b[x,y][1]=me do
      begin
      x:=1;
      while (b[x,y][1]=me) and (x<8) do
        x:=x+1;
      y:=y+1;
      end;
    x2:=x;
    y2:=y;
    retval:=false;
    end
  else
    begin
    if retval then
      begin
      x:=0;
      y:=0;
      x2:=0;
      y2:=0;
      for i := 1 to 2 do
        case ord(s[i]) of
        48..57 : begin
                 y := ord(s[i])-ord('0');
                 end;
        65..72 : begin
                 x := ord(s[i])-ord('@');
                 end;
        end; { of case }
      for i := 3 to 4 do
        case ord(s[i]) of
        48..57 : begin
                 y2 := ord(s[i])-ord('0');
                 end;
        65..72 : begin
                 x2 := ord(s[i])-ord('@');
                 end;
        end; { of case }
      if me='B' then
        begin
        x:=9-x;
        y:=9-y;
        x2:=9-x2;
        y2:=9-y2;
        end;
      if ((x=0) or (y=0) or (x2=0) or (y2=0)) then
        begin
        x:=1;
        y:=1;
        while b[x,y][1]=me do
          begin
          while b[x,y][1]=me do
            x:=x+1;
          y:=y+1;
          end;
        x2:=x;
        y2:=y;
        retval:=false;
        end;
      end;
    end;
  readmove:=retval;
end; { of ReadMove }

function doit(var b:board;
              var m:integer;
                  me:char;
              var line1,line2:linetype;
                  p1,p2:string) : boolean;
  var x,y,x2,y2:integer;
      ok,retval:boolean;
      c,him    :char;
      l1,l2    :string;
begin
  l1:='';
  l2:='';
  drawboard(b,me,m,p1,p2);
  retval:=true;
  if me='W' then
    him:='B'
  else
    him:='W';
  repeat
    if line1<>'' then
      writestrln(line1);
    if line2<>'' then
      writestrln(line2);
    if (me='B') then
      writestrln('You are black')
    else
      writestrln('You are white');
    if checkcheck(b,me) then
      if checkmate(b,me) then
        begin
        writestrln('You are in checkmate! You can not have a move, Sorry.');
        exit;
        end
      else
        writestrln('You are in Check.');
    repeat
      repeat
        writestr(chr(13)+'Move :      '+chr(8)+chr(8)+chr(8)+chr(8)+chr(8));
        ok:=ReadMove(b,x,y,x2,y2,me,l1,l2);
        if ((b[x,y][1]<>me) and ok) or (not ok) then
          begin
          writestr(chr(13)+'Invalid move, Try again (Y/N) ? ');
          repeat
            c:=upcase(inkey);
          until c in ['Y','N',chr(27),chr(13)];
          ok:=c='Y';
          writestr(chr(13)+'                                ');
          end;
      until (((b[x,y][1]=me) and ok) or (not ok));
      if not ok then
        begin
        c:=chr(27);
        ok:=True
        end
      else
        begin
        ok:=domove(b,x,y,x2,y2,true);
        if ok then
          m:=m+1
        else
          begin
          writestr(chr(13)+'Invalid move, Try again (Y/N) ? ');
          repeat
            c:=upcase(inkey);
          until c in ['Y','N',chr(27)];
          ok:=c<>'Y';
          retval:=c='Y';
          writestr(chr(13)+'                                ');
          end;
        end;
    until (ok);
    writestrln('');
  until ok;
  if c<>chr(27) then
    begin
    drawboard(b,me,m,p1,p2);
    if (checkcheck(b,him)) then
      begin
      writestr('He is in check ');
      if checkmate(b,him) then
        begin
        writestr('He is in Checkmate.');
        retval:=true;
        end;
      writestrln('');
      end
    else
      begin
      if stalemate(b,him) then
        begin
        writestrln('Stupid Stupid. It is Stalemate!');
        retval:=true
        end
      else
        retval:=false;
      end;
    writestr('Do you want to leave your opponent a Message (Y/N) ?');
    repeat
      c:=upcase(inkey);
    until ((c=chr(27)) or (c=chr(13)) or (c='Y') or (c='N'));
    if (c=chr(13)) or (c='Y') then
      begin
      writestrln('');
      writestr(':');
      readstrln(l1,79);
      writestr(':');
      readstrln(l2,79);
      writestrln('Thanks for that now back to the beaten bush.');
      end;
    end
  else
    retval:=false;
  line1:=l1;
  line2:=l2;
  doit:=retval;
end; { of proc doit }

function FindMygames(var pno:integer) : gameptr;
{ this procedure writes on the screen games He is involved in games waiting
    for a player and Games its his turn in }
var
  f  : file of boardrec;
  f2 : file of player;
  p  : player;
  b  : boardrec;
  j  : integer;
  s  : string;
  g1,g2,first,last
     : gameptr;
begin
  new(g1);
  last:=nil;
  first:=g1;
  g1^.next:=nil;
  p.name:='';
  assign(f2,'CPLAYER.DAT');
  {$I-}
  reset(f2);
  {$I+}
  if IOResult<>0 then
    rewrite(f2);
  while ((not eof(f2)) and (p.name<>username)) do
    read(f2,p);
  if p.name=username then
    begin
    pno:=filepos(f2)-1;
    end
  else
    begin
    pno:=filesize(f2);
    seek(f2,pno);
    p.name:=username;
    p.gameswon:=0;
    p.gamesplayed:=0;
    write(f2,p);
    end;
  close(f2);
  assign(f,'CGAMES.DAT');
  {$I-}
  reset(f);
  {$I+}
  if IOResult<>0 then
    rewrite(f);
  textcolor(red);
  writestrln('Games you are involved in');
  textcolor(yellow);
  while (not eof(f)) do
    begin
    read(f,b);
    if ((b.player1=pno) or (b.player2=pno)) then
      begin
      g1^.gameno:=filepos(f)-1;
      g1^.p1:=b.player1;
      g1^.p2:=b.player2;
      g1^.line1:=b.line1;
      g1^.line2:=b.line2;
      g1^.finished:=false;
      str(g1^.gameno:2,s);
      writestr ('    '+s+': ');
      writestr(playername(b.player1));
      writestr (' vs ');
      writestr(playername(b.player2));
      if (b.timefin=0) then
        if ((b.nomoves mod 2)=1) then
          if (b.player2=pno) then
            begin
            Writestrln('  (Your Move)');
            g1^.myturn:=true;
            end
          else
            begin
            Writestrln('  (His Move)');
            g1^.myturn:=false;
            end
        else
          if (b.player1=pno) then
            begin
            writestrln('  (Your Move)');
            g1^.myturn:=true;
            end
          else
            begin
            writestrln('  (His Move)');
            g1^.myturn:=false;
            end
      else
        begin
        writestrln('  (Finished)');
        g1^.myturn:=false;
        g1^.finished:=true;
        end;
      g1^.waiting := false;
      g1^.nom := b.nomoves;
      new(g2);
      g1^.next:=g2;
      last:=g1;
      g1:=g2;
      end;
    end;
  textcolor(red);
  writestrln('');
  writestrln('Games Needing players');
  textcolor(yellow);
  seek(f,0);
  while (not eof(f)) do
    begin
    read(f,b);
    if ((b.player1=-1) or (b.player2=-1)) then
      begin
      if (b.player1<>pno) then
        begin
        g1^.gameno:=filepos(f)-1;
        g1^.p1:=b.player1;
        g1^.p2:=b.player2;
        g1^.line1:=b.line1;
        g1^.line2:=b.line2;
        str(g1^.gameno:2,s);
        writestr ('    '+s+': ');
        writestr(playername(b.player1));
        writestr (' vs ');
        writestr(playername(b.player2));
        writestrln('');
        g1^.waiting:=true;
        g1^.myturn :=false;
        g1^.finished:=false;
        new(g2);
        g1^.next:=g2;
        g1^.nom:=b.nomoves;
        last:=g1;
        g1:=g2;
        end;
      end;
    end;
  textcolor(lightgray);
  close(f);
  g2:=last;
  dispose(g1);
  if (g2=nil) then
    findmygames:=nil
  else
    begin
    g2^.next:=nil;
    findmygames:=first;
    end;
end; { of proc find my games }

procedure Taketurn(p:gameptr;
                   pno:integer);
var
  g:gameptr;
  s:string;
  i,j,whowon,stmov:integer;
  c,me:char;
  b:board;
begin
  g:=p;
  if (p=nil) then
    begin
    Writestrln('You are not involved in any games yet');
    Writestrln('');
    Writestrln('Press any key to continue');
    c:=inkey;
    end
  else
    begin
    i := 0;
    textcolor(red);
    writestrln('Chose the game to play : ');
    textcolor(yellow);
    repeat
      if ((g^.myturn) and (not g^.waiting)) then
        begin
        writestr('  <'+chr(i+65)+'> ');
        writestr(playername(g^.p1));
        writestr(' vs ');
        writestr(playername(g^.p2));
        writestrln('');
        i:=i+1;
        end;
      g:=g^.next;
    until g=nil;
    textcolor(lightgray);
    if (i=0) then
      begin
      writestrln('Sorry you have taken all your turns in your current games');
      writestrln('');
      writestrln('Waiting ...');
      c:=inkey;
      end
    else
      begin
      writestrln('');
      writestr('Which Game [A..'+chr(i+64)+'] (Q or return to quit) ?');
      repeat
        c:=upcase(inkey);
      until ((c in ['Q',chr(13),chr(27)]) or ((c>='A') and (c<=chr(i+64))));
      if ((c>='A') and (c<=chr(i+64))) then
        begin
        g:=p;
        i:=ord(c)-65;
        while (not g^.myturn) do
          g:=g^.next;
        while ((i>0)) do
          begin
          repeat
            g:=g^.next;
          until g^.myturn;
          i:=i-1;
          end;
        Unpackgame(b,g^.gameno,g^.nom);
        if (pno=g^.p1) then
          me:='W'
        else
          me:='B';
        whowon:=0;
        stmov:=g^.nom;
        if (doit(b,g^.nom,me,g^.line1,g^.line2,playername(g^.p1),playername(g^.p2))) then
          begin
          end;
        if g^.nom<>stmov then
          packgame(b,g^.gameno,g^.nom,g^.line1,g^.line2);
        if checkmate(b,'W') then
          begin
          Iwon(g^.p2,g^.p1);
          finishgame(g^.gameno);
          end;
        if checkmate(b,'B') then
          begin
          Iwon(g^.p1,g^.p2);
          finishgame(g^.gameno);
          end;
        if me='W' then
          me:='B'
        else
          me:='W';
        if stalemate(b,me) then
          begin
          writestrln('Stalemate. Oh dear what a silly Bunt.');
          Idraw(g^.p1,g^.p2);
          finishgame(g^.gameno);
          writestr('Waiting ...');
          if (inkey='C') then
            writestrln('You pushed the C key for fun but I like fish.');
          end;
        if (whowon<>0) then
          begin
          if (whowon=pno) then
            writestrln('Congratulations YOU HAVE WON. YAYAYAYAYAY.')
          else
            writestrln('Oh well you lost. Never mind better luck next time.');
          writestr('Waiting ...');
          if (inkey='C') then
            writestrln('You pushed the C key for fun but I like fish.');
          end;
        end;
      end;
    end;
end; { of proc taketurn }

procedure startnew(p:gameptr;
                 pno:integer);
  var
    h:gameptr;
    f:file of boardrec;
    q:longint;
    line1,
    line2:linetype;
    b1:boardrec;
    b:board;
    i,g:integer;
    z,dropout:boolean;
    c:char;
begin
  h:=p;
  i:=0;
  g:=0;
  while (h<>nil) do
    begin
    if ((h^.p1=pno) or (h^.p2=pno)) then
      i:=i+1;
    if ((h^.p1=pno) and (h^.p2=-1)) then
      g:=g+1;
    h:=h^.next;
    end;
  writestr('You are already involved in ');
  writeint(i);
  writestrln(' games');
  writestrln('');
  if ((i>maxgames) or (g>maxhanging)) then
    begin
    if (g>maxhanging) then
      begin
      writestr('I am sorry but you can only have ');
      writeint(maxhanging);
      writestrln(' games hanging');
      writestrln('');
      end
    else
      begin
      writestrln('And I am sorry but that is the house limit around here');
      writestrln('');
      end;
    writestr('Waiting ...');
    c:=inkey;
    end
  else
    begin
    writestr('Are you sure you want to start a new game [Y/N] ? ');
    repeat
      c:=upcase(inkey);
    until c in ['Y','N',chr(27)];
    if c='Y' then
      begin
      writestrln('Good');
      initboard(b);
      i:=0;
      line1:='';
      line2:='';
      z:=doit(b,i,'W',line1,line2,playername(pno),'');
      if (i=1) then
        begin
        assign(f,'CGAMES.DAT');
        reset(f);
        dropout:=false;
        q:=getthetime;
        while ((not eof(f)) and (not dropout)) do
          begin
          read(f,b1);
          if (b1.timefin<>0) then
            if (q>=(b1.timefin+20160)) then
              begin
              dropout:=true;
              g:=filepos(f)-1;
              end;
          end;
        if not dropout then
          g:=filesize(f);
        seek(f,g);
        b1.player1:=pno;
        b1.player2:=-1;
        b1.timefin:=0;
        b1.timestart:=getthetime;
        write(f,b1);
        close(f);
        PackGame(b,g,i,line1,line2);
        end;
      end;
    end;
end; { of proc startnew }

procedure JoinGame(p:gameptr;
                   pno:integer);
  var
    b:board;
    s:string;
    b1:boardrec;
    i,j:integer;
    z:boolean;
    f:file of boardrec;
    g:gameptr;
    c:char;
begin
  i:=0;
  g:=p;
  textcolor(red);
  writestrln('Availible Games to Join ');
  textcolor(yellow);
  while (g<>NIl) do
    begin
    if (g^.waiting) then
      begin
      writestr(chr(i+65)+'  ');
      writestr(playername(g^.p1));
      writestr(' vs ');
      writestr(playername(g^.p2));
      writestrln('');
      i:=i+1;
      end;
    g:=g^.next;
    end;
  textcolor(lightgray);
  if (i=0) then
    begin
    writestrln('');
    writestrln('Sorry there are no games for you to join press any key to continue');
    writestrln('');
    writestrln('Waiting ...');
    c:=inkey;
    end
  else
    begin
    writestrln('');
    writestr('Which game do you want to join [A..'+chr(i+64)+'] ? ');
    repeat
      c:=upcase(inkey);
    until ((c in [chr(13),'Q',chr(27)]) or ((c>='A') and (c<=chr(64+i))));
    if ((c>='A') and (c<=chr(64+i))) then
      begin
      g:=p;
      j:=0;
      i:=ord(c)-64;
      while (i<>j) do
        begin
        if (g^.waiting) then
          j:=j+1;
        if (i<>j) then
          g:=g^.next;
        end;
      Unpackgame(b,g^.gameno,g^.nom);
      z:=doit(b,g^.nom,'B',g^.line1,g^.line2,playername(g^.p1),playername(pno));
      if g^.nom=2 then
        begin
        assign(f,'CGAMES.DAT');
        reset(f);
        seek(f,g^.gameno);
        read(f,b1);
        b1.player2:=pno;
        seek(f,g^.gameno);
        write(f,b1);
        close(f);
        packgame(b,g^.gameno,g^.nom,g^.line1,g^.line2);
        end;
      end;
    end;
end; { of proc JoinGame }

procedure RankPlayers(ime:integer);
  var
    f:file of player;
    p,me:player;
    player,score : array [0..20] of integer;
    i,j:integer;
    c:char;
    s:string;
begin
  for i:=0 to 20 do
    begin
    player[i]:=-1;
    score[i]:=-1;
    end;
  assign(f,'CPLAYER.DAT');
  reset(f);
  while (not eof(f)) do
    begin
    read(f,p);
    i:=20;
    while ((score[i]<p.gameswon) and (i>0)) do
      i:=i-1;
    if i<>20 then
      begin
      if score[i+1]<>-1 then
        for j := 20 downto i+1 do
          score[j]:=score[j-1];
      if player[i+1]<>-1 then
        for j := 20 downto i+1 do
          player[j]:=player[j-1];
      score[i+1]:=p.gameswon;
      player[i+1]:=filepos(f)-1
      end;
    end;
  seek(f,ime);
  read(f,me);
  close(f);
  clrscr;
  textcolor(red);
  writestrln('Top Scorers to date ');
  for i:=1 to 20 do
    begin
    textcolor(yellow);
    if player[i]<>-1 then
      begin
      str(i:2,s);
      writestr(s+':'+playername(player[i]));
      if ansion then
        gotoxy(33,wherey)
      else
        for j:=wherex to 33 do
          writestr(' ');
      textcolor(lightgray);
      writeint(score[i]);
      writestrln('');
      end;
    end;
  writestrln('');
  writestr('Your Score is ');
  writeint(me.gameswon);
  writestr(' and you have played ');
  writeint(me.gamesplayed);
  writestrln(' games.');
  writestr('Press any key to continue');
  c:=inkey;
end; { will give up to the top ten players }

procedure Viewgame(p:gameptr;
                   pno:integer);
  var
    i:integer;
    g:gameptr;
    c:char;
    b:board;
begin
  i:=0;
  g:=p;
  textcolor(red);
  writestrln('Possible games to view ');
  textcolor(yellow);
  while (g<>nil) do
    begin
    writestr('  '+chr(i+65)+' - ');
    if (g^.nom mod 2) = 0 then
      textcolor(red)
    else
      textcolor(lightgray);
    writestr(playername(g^.p1));
    textcolor(lightgray);
    writestr(' vs ');
    if (g^.nom mod 2) = 1 then
      textcolor(red)
    else
      textcolor(lightgray);
    writestr(playername(g^.p2));
    textcolor(lightgray);
    if g^.finished then
      writestrln('  (Finished)')
    else
      if (g^.myturn) then
        writestrln('  (My move)')
      else
        writestrln('  (His move)');
    g:=g^.next;
    i:=i+1;
    end;
  textcolor(lightgray);
  if i=0 then
    begin
    writestrln('');
    writestrln('Sorry there are no game you can view');
    writestrln('');
    writestr('Waiting ...');
    c:=inkey;
    end
  else
    begin
    writestr('Select : ');
    repeat
      c:=upcase(inkey);
    until ((c in [chr(13),chr(27)]) or ((c>='A') and (c<=chr(64+i))));
    if ((c>='A') and (c<=chr(64+i))) then
      begin
      g:=p;
      i:=ord(c)-65;
      while ((i>0) and (g<>nil)) do
        begin
        i:=i-1;
        g:=g^.next;
        end;
      unpackgame(b,g^.gameno,g^.nom);
      if (g^.nom) mod 2=0 then
        drawboard(b,'W',g^.nom,playername(g^.p1),playername(g^.p2))
      else
        drawboard(b,'B',g^.nom,playername(g^.p1),playername(g^.p2));
      writestrln('Press any key to continue');
      writestrln('');
      writestr('Waiting ...');
      c:=inkey;
      end;
    end;
end; { of proc ViewGame }

procedure Listgames;
var
  f:file of boardrec;
  i,x,o:integer;
  b:boardrec;
  b1:board;
  ch:char;
  nom,gameno:integer;
begin
  assign (f,'CGAMES.DAT');
  reset(f);
  writestrln ('');
  writestrln ('');
  textcolor(red);
  Writestrln ('    Games currently active and scores for them');
  writestrln ('');
  textcolor(yellow);
  i:=0;
  while not eof(f) do
    begin
    read(f,b);
    textcolor(red);
    writestr(chr((i mod 20)+65)+' ');
    textcolor(yellow);
    writeint(i);
    if b.timefin<>0 then
      ch:='F'
    else
      ch:=':';
    if (i<10) then
      writestr(ch+'   ')
    else
      if (i<100) then
        writestr(ch+'  ')
      else
        writestr(ch+' ');
    textcolor(lightgray);
    writestr('Move ');
    writeint(b.nomoves);
    if (b.nomoves<10) then
      writestr ('.  Score ')
    else
      writestr ('. Score ');
    unpackgame2(b1,b);
    nopoints(b1,x,o);
    writeint(x);
    writestr(',');
    writeint(o);
    writestr('. ');
    if (b.nomoves mod 2) =0 then
      if ansion then
        textcolor(red)
      else
        writestr('*');
    writestr(playername(b.player1));
    textcolor(lightgray);
    writestr(' vs ');
    if (b.nomoves mod 2) =1 then
      if ansion then
        textcolor(red)
      else
        writestr('*');
    writestr(playername(b.player2));
    textcolor(lightgray);
    writestrln('.');
    i:=i+1;
    if ((i mod 20)=0) then
      begin { ok now we ask which game? }
      textcolor(lightgray);
      writestr(' Which game do you want to view (space or CR next page) (A-'+chr(((i-1) mod 20)+65)+') ? ');
      ch:=upcase(inkey);
      if (ch in ['A'..chr(((i-1) mod 20)+65)]) then
        begin
        gameno:=((i div 20)-1)*20 + (ord(ch)-ord('A'));
        unpackgame(b1,gameno,nom);
        seek(f,gameno);
        read(f,b);
        if (nom mod 2)=0 then
          drawboard(b1,'W',b.nomoves,playername(b.player1),playername(b.player2))
        else
          drawboard(b1,'B',b.nomoves,playername(b.player1),playername(b.player2));
        Writestr('This game is between ');
        writestr(playername(b.player1));
        writestr(' and ');
        writestr(playername(b.player2));
        writestrln('.');
        writestrln('Press any key to continue');
        writestrln('');
        writestr('Waiting ...');
        ch:=inkey;
        seek(f,i);
        clrscr;
        end
      else
        writestrln('');
      end;
    end;
  if (i mod 20<>0) then
    begin
    textcolor(lightgray);
    writestr(' Which game do you want to view (space or CR to quit) (A-'+chr(((i-1) mod 20)+65)+') ? ');
    ch:=upcase(inkey);
    if (ch in ['A'..chr(((i-1) mod 20)+65)]) then
      begin
      gameno:=(i div 20)*20 + (ord(ch)-ord('A'));
      unpackgame(b1,gameno,nom);
      seek(f,gameno);
      read(f,b);
      if (nom mod 2)=0 then
        drawboard(b1,'W',b.nomoves,playername(b.player1),playername(b.player2))
      else
        drawboard(b1,'B',b.nomoves,playername(b.player1),playername(b.player2));
      writestr('This game is between ');
      writestr(playername(b.player1));
      writestr(' and ');
      writestr(playername(b.player2));
      writestrln('.');
      writestrln('Press any key to continue');
      writestrln('');
      writestr('Waiting ...');
      ch:=inkey;
      end;
    end;
  close(f);
 end; { of proc Listgames }

procedure ScoreChange;
  var
    i,change,d,points:integer;
    s:string;
    f:file of player;
    p:player;
begin
  writestrln('');
  writestrln('Score changeing operation');
  writestrln('');
  writestr('Name of person whose points you wish to modify ? ');
  readstrln(s,250);
  i:=findplayer(s);
  if i=-1 then
    writestrln('Sorry he does not exist. Bang.')
  else
    begin
    writestrln('');
    writestrln('');
    points:=score(i);
    writestr('He has ');
    writeint(points);
    writestrln('points.');
    writestr('Number of points to modify it by ?');
    readstrln(s,250);
    val(s,change,d);
    assign(f,'PLAYER.DAT');
    reset(f);
    seek(f,i);
    read(f,p);
    p.gameswon:=p.gameswon+change;
    seek(f,i);
    write(f,p);
    close(f);
    end;
end; { of proc scorechange}

procedure BeginScreen;
 var
  p,g:gameptr;
  finished : boolean;
  c:char;
  pno,i,lenstr:integer;
  selectset : set of char;
 begin
  finished := false;
  if securitylevel>=sysopsec then
    selectset:=['Q','T','S','J','V','R','L','C','B',chr(27)]
  else
    selectset:=['Q','T','S','J','V','R','L',chr(27)];
  repeat
    colour(lightgray,black);
    clrscr;
    colour(Yellow,red);
    lenstr := length('Whelk Chess ') + length(bbsname);
    for i := 1 to (80 - lenstr) div 2 do
      writestr(' ');
    writestr('Whelk Chess ' + bbsname);
    for i := 1 to (80 - lenstr) div 2 + lenstr mod 2 do
      writestr(' ');
    writestrln('');
    colour(lightgray,black);
    p:=findmygames(pno);
    Writestrln('');
    writestrln('Ok '+UserName+' here are your choices');
    writestrln('');
    Writestr('    <');
    textcolor(yellow);
    writestr('T');
    textcolor(lightgray);
    writestrln('>ake your turn in a game ');
    Writestr('    <');
    textcolor(yellow);
    writestr('S');
    textcolor(lightgray);
    writestrln('>tart a new game');
    Writestr('    <');
    textcolor(yellow);
    writestr('J');
    textcolor(lightgray);
    writestrln('>oin a started game');
    writestr('    <');
    textcolor(yellow);
    writestr('V');
    textcolor(lightgray);
    writestrln('>iew a game in progress');
    writestr('    <');
    textcolor(yellow);
    writestr('R');
    textcolor(lightgray);
    writestrln('>ank players of this game');
    writestr('    <');
    textcolor(yellow);
    writestr('L');
    textcolor(lightgray);
    writestrln('>ist all the games in progress');
    textcolor(red);
    Writestr('    <');
    textcolor(yellow);
    writestr('Q');
    textcolor(red);
    writestrln('>uit');
    textcolor(lightgray);
    writestrln('');
    writestr(' Select : ');
    repeat
      c:=upcase(inkey);
    until c in selectset;
    writestrln('');
    case c of
      chr(27),
      'Q' : finished := true;
      'T' : taketurn(p,pno);
      'S' : startnew(p,pno);
      'J' : joingame(p,pno);
      'V' : viewgame(p,pno);
      'R' : rankplayers(pno);
      'L' : listgames;
      'B' : bashgames;
      'C' : scorechange;
    end; { of case }
    while (p<>nil) do
      begin
      g:=p^.next;
      dispose(p);
      p:=g;
      end;
  until finished;
end; { of beginscreen }

begin
  if (readcontrolfile(paramstr(1))) then
    begin
    if ((portno<>0) and (baudrate<>0)) then
      begin
      initfossil(portno);
      setbaud(portno,baudrate);
      end;
    BeginScreen;
    end
  else
    writeln('Invalid control file or file not found');
  if fossilinstalled then
    uninitfossil(portno);
end. { of prog Reversi }
