unit chessbash;
{ This file has the chess bashing routines in it to bash the chess game }

interface


procedure BashGames;

implementation

uses fosout,
     crt,
     fossil,
     chesutil,
     chestype;

function BashGame(var b:boardrec;
                  var b1:board) : boolean;
var
  ch:char;
  x,y, ox, oy: integer;
  colour,bor : char;
  procedure setpiece(ch:char);
    var i,j: integer;
  begin
    if (ox<8) then
      ox := ox +1
    else
      ox := 1;
    if ch in ['1'..'9'] then
      begin
      if b1[9-x,y][1] <> ' ' then
        begin
        if ch in ['9','8'] then
          for i := 1 to 8 do
            for j := 1 to 8 do
              if b1[i,j][3] in ['8','9'] then
                 b1[i,j][3] := '2';
        b1[9-x,y][3] := ch;
        end;
      end
    else
      if b1[9-x,y][1] = ' ' then
        b1[9-x,y] := colour + ch + '1'
      else
        b1[9-x,y] := colour + ch + b1[9-x,y][3];
  end;
begin
  x := 1;
  y := 1;
  ox := 2;
  oy := 2;
  colour := 'B';
  drawboard(b1,'B',b.nomoves,playername(b.player1),playername(b.player2));
  writestrln('Help: <T>oggle insert colour, <F>lip colour of piece, <Z>ap game (finish)');
  writestrln('Moves:   <1> piece unmoved, <2> piece moved, <8> last move pawn moved 2');
  writestrln('         <9> last piece moved.  <->1 number of moves, <+>1 number of moves');
  writestrln('Insert: K<i>ng, Q<u>een, <P>awn, <R>ook, K<n>ight, <B>ishop.  <Q>uit, <S>ave');
  if b.timefin <> 0 then
    begin
    gotoxy(65,1);
    textcolor(white);
    textbackground(black);
    writestr('Finished');
    end;
  textcolor(lightgray);
  textbackground(black);
  gotoxy(40,1);
  writestr('Insert Colour : ');
  textcolor(white);
  writestr('Black');
  repeat
    if (ox<>x) or (oy<>y) then
      begin
      if ((ox+oy) mod 2) = 0 then
        textbackground(black)
      else
        textbackground(lightgray);
      if (b1[9-ox,oy][1] = 'B') then
        if ((ox+oy) mod 2) = 0 then
          textcolor(lightgray)
        else
          textcolor(black)
      else
        textcolor(white);
      if (b1[9-x,y][1] = ' ') then
        bor := '+'
      else
        bor := b1[9-x,y][3];
      gotoxy(ox*4,2+oy*2);
      writestr(' '+b1[9-ox,oy][1]+b1[9-ox,oy][2]+' ');
      gotoxy(x*4,2+y*2);
      textcolor(white);
      textbackground(green);
      writestr(bor+b1[9-x,y][1]+b1[9-x,y][2]+bor);
      ox :=x;
      oy :=y;
      end;
    ch := upcase(readkey);
    case ch of
      'L' : if (x<8) then
              x:= x+1;
      'H' : if (x>1) then
              x:= x-1;
      'J' : if (y<8) then
              y:= y+1;
      'K' : if (y>1) then
              y:= y-1;
      'F' : begin
            if ox<8 then
              ox := ox+1
            else
              ox := 1;
            if b1[9-x,y][1] <> ' ' then
              if b1[9-x,y][1] = 'B' then
                b1[9-x,y][1] := 'W'
              else
                b1[9-x,y][1] := 'B';
            end;
      'P' : setpiece('P');
      'N' : setpiece('N');
      'I' : setpiece('K');
      'R' : setpiece('R');
      'B' : setpiece('B');
      'U' : setpiece('Q');
      '1' : setpiece('1');
      '2' : setpiece('2');
      '8' : setpiece('8');
      '9' : setpiece('9');
      'Z' : if b.timefin = 0 then
              begin
              gotoxy(65,1);
              textcolor(white);
              textbackground(black);
              writestr('Finished');
              b.timefin := getthetime
              end
            else
              begin
              gotoxy(65,1);
              textcolor(white);
              textbackground(black);
              writestr('        ');
              b.timefin := 0;
              end;
      '-' : begin
            b.nomoves := b.nomoves - 1;
            if (b.nomoves <= 1) then
              b.nomoves := 1;
            end;
      '+' : b.nomoves := b.nomoves + 1;
      ' ' : begin
            if ox<8 then
              ox := ox+1
            else
              ox := 1;
            b1[9-x,y] := '  ';
            end;
      'T' : begin
            if colour = 'B' then
              colour := 'W'
            else
              colour := 'B';
            textcolor(lightgray);
            textbackground(black);
            gotoxy(40,1);
            writestr('Insert Colour : ');
            textcolor(white);
            if colour = 'B' then
              writestr('Black')
            else
              writestr('White');
            end;
    end;
  until (ch='Q') or (ch='S') or (ch=chr(27));
  bashgame := ch='S';
end; { of func BashGame }

procedure Bashgames;
var
  f:file of boardrec;
  i,x,o:integer;
  b:boardrec;
  b1:board;
  ch:char;
  nom,gameno:integer;
  oldtimfin:longint;
begin
  assign (f,'CGAMES.DAT');
  reset(f);
  writestrln ('');
  writestrln ('');
  textcolor(red);
  Writestrln ('    Games currently active and scores for them');
  writestrln ('');
  textcolor(yellow);
  i:=0;
  while not eof(f) do
    begin
    read(f,b);
    textcolor(red);
    writestr(chr((i mod 20)+65)+' ');
    textcolor(yellow);
    writeint(i);
    if b.timefin<>0 then
      ch:='F'
    else
      ch:=':';
    if (i<10) then
      writestr(ch+'   ')
    else
      if (i<100) then
        writestr(ch+'  ')
      else
        writestr(ch+' ');
    textcolor(lightgray);
    writestr('Move ');
    writeint(b.nomoves);
    if (b.nomoves<10) then
      writestr ('.  Score ')
    else
      writestr ('. Score ');
    unpackgame2(b1,b);
    nopoints(b1,x,o);
    writeint(x);
    writestr(',');
    writeint(o);
    writestr('. ');
    if (b.nomoves mod 2) =0 then
      if ansion then
        textcolor(red)
      else
        writestr('*');
    writestr(playername(b.player1));
    textcolor(lightgray);
    writestr(' vs ');
    if (b.nomoves mod 2) =1 then
      if ansion then
        textcolor(red)
      else
        writestr('*');
    writestr(playername(b.player2));
    textcolor(lightgray);
    writestrln('.');
    i:=i+1;
    if ((i mod 20)=0) then
      begin { ok now we ask which game? }
      textcolor(lightgray);
      writestr(' Which game do you want to view (space or CR next page) (A-'+chr(((i-1) mod 20)+65)+') ? ');
      ch:=upcase(inkey);
      if (ch in ['A'..chr(((i-1) mod 20)+65)]) then
        begin
        gameno:=((i div 20)-1)*20 + (ord(ch)-ord('A'));
        unpackgame(b1,gameno,nom);
        seek(f,gameno);
        read(f,b);
        oldtimfin := b.timefin;
        if bashgame(b,b1) then
          begin
          packgame(b1,gameno,b.nomoves,'','');
          if b.timefin <> oldtimfin then
            if b.timefin = 0 then
              unfinishgame(gameno)
            else
              finishgame(gameno);
          end;
        seek(f,i);
        clrscr;
        end
      else
        writestrln('');
      end;
    end;
  if (i mod 20<>0) then
    begin
    textcolor(lightgray);
    writestr(' Which game do you want to view (space or CR to quit) (A-'+chr(((i-1) mod 20)+65)+') ? ');
    ch:=upcase(inkey);
    if (ch in ['A'..chr(((i-1) mod 20)+65)]) then
      begin
      gameno:=(i div 20)*20 + (ord(ch)-ord('A'));
      unpackgame(b1,gameno,nom);
      seek(f,gameno);
      read(f,b);
      if bashgame(b,b1) then
        begin
        packgame(b1,gameno,b.nomoves,'','');
        if b.timefin <> oldtimfin then
          if b.timefin = 0 then
            unfinishgame(gameno)
          else
            finishgame(gameno);
        end;
      end;
    end;
  close(f);
 end; { of proc Listgames }

end.