unit chessmov;
{
   Copyleft Message from your Sponsor:

        This program is utterly copyright (c) David Bennett, 1990
        and WhelkSoft, his 'software label', also 1990.
        Except for the bits that are copyright Borland Software.
        The actual code is distributed according to a vaguely
        Free Software Foundation license.  That is:

        You can copy the source and binaries.  You can distribute
        them to everyone you know.  However:

        1. You MAY NOT charge for the program, except for a reasonable
        cost of media and transportation.

        2. The original program was written by David Bennett and
        original authorship still resides with him.  So, you must
        distribute code still having his copyright messages.

        3. We strongly recommend that any site having or using this
        software should have the original sourcecode available to
        anyone who wants it.  Further development of computing in
        general may depend on sharing expertise and code.

        4. The above conditions should apply to any further
        development of this program.

        Please send the University Computer Club (oh, and David
        Bennett) some sort of postcard from where you are and how
        much you hate Whelk Chess ... we like to have our egos stroked!

}

interface

uses
  chestype;

function checkcheck(b:board;
                    me:char) : boolean;

function StaleMate(b:board;
                  me:char) : boolean;

function checkmate(b:board;
                   me:char) : boolean;

function domove(var b:board;
                x,y,x2,y2:integer;
                doit:boolean):boolean;

var
  matearray:matearraytype;

implementation

function checkcheck(b:board;
                    me:char) : boolean;
  var
    i,j,dir: integer;
    tmp:boolean;
  function checkhoriz(i,j:integer) : boolean;
    var tmp:boolean;
        k,l:integer;
  begin
    tmp:=false;
    k:=i-1;
    while ((k>=1) and (b[k,j]='  ')) do
      k:=k-1;
    if (k>=1) then
      if ((b[k,j][2]='K') and (b[k,j][1]=me)) then
        begin
        l:=i;
        while (l>k) do
          begin
          matearray[l,j]:=true;
          l:=l-1;
          end;
        tmp:=true;
        end;
    k:=i+1;
    while ((k<=8) and (b[k,j]='  ')) do
      k:=k+1;
    if (k<=8) then
      if ((b[k,j][2]='K') and (b[k,j][1]=me)) then
        begin
        l:=i;
        while (k>l) do
          begin
          matearray[l,j]:=true;
          l:=l+1;
          end;
        tmp:=true;
        end;
    k:=j-1;
    while ((k>=1) and (b[i,k]='  ')) do
      k:=k-1;
    if (k>=1) then
      if ((b[i,k][2]='K') and (b[i,k][1]=me)) then
        begin
        tmp:=true;
        l:=j;
        while (k<l) do
          begin
          matearray[i,l]:=true;
          l:=l-1;
          end;
        end;
    k:=j+1;
    while ((k<=8) and (b[i,k]='  ')) do
      k:=k+1;
    if (k<=8) then
      if ((b[i,k][2]='K') and (b[i,k][1]=me)) then
        begin
        tmp:=true;
        l:=j;
        while (k>l) do
          begin
          matearray[i,l]:=true;
          l:=l+1;
          end;
        end;
    checkhoriz:=tmp;
  end;
  function checkdiag(i,j:integer) : boolean;
    var tmp,zoop:boolean;
        k,l,m,n:integer;
  begin
    tmp:=false;
    k:=i+1;
    l:=j+1;
    while ((k<=8) and (l<=8) and (b[k,l]='  ')) do
      begin
      k:=k+1;
      l:=l+1;
      end;
    if ((k<=8) and (l<=8)) then
      if ((b[k,l][2]='K') and (b[k,l][1]=me)) then
        begin
        tmp:=true;
        m:=i;
        n:=j;
        while (m<k) do
          begin
          matearray[m,n]:=true;
          m:=m+1;
          n:=n+1;
          end;
        end;
    k:=i-1;
    l:=j+1;
    while ((k>=1) and (l<=8) and (b[k,l]='  ') and (not tmp)) do
      begin
      k:=k-1;
      l:=l+1;
      end;
    if ((k>=1) and (l<=8) and (not tmp)) then
      if ((b[k,l][2]='K') and (b[k,l][1]=me)) then
        begin
        tmp:=true;
        m:=i;
        n:=j;
        while (m>k) do
          begin
          matearray[m,n]:=true;
          m:=m-1;
          n:=n+1;
          end;
        end;
    k:=i+1;
    l:=j-1;
    while ((k<=8) and (l>=1) and (b[k,l]='  ') and (not tmp)) do
      begin
      k:=k+1;
      l:=l-1;
      end;
    if ((k<=8) and (l>=1) and (not tmp)) then
      if ((b[k,l][2]='K') and (b[k,l][1]=me)) then
        begin
        tmp:=true;
        m:=i;
        n:=j;
        while (m<k) do
          begin
          matearray[m,n]:=true;
          m:=m+1;
          n:=n-1;
          end;
        end;
    k:=i-1;
    l:=j-1;
    while ((k>=1) and (l>=1) and (b[k,l]='  ') and (not tmp)) do
      begin
      k:=k-1;
      l:=l-1;
      end;
    if ((k>=1) and (l>=1) and (not tmp)) then
      if ((b[k,l][2]='K') and (b[k,l][1]=me)) then
        begin
        tmp:=true;
        m:=i;
        n:=j;
        while (m>k) do
          begin
          matearray[m,n]:=true;
          m:=m-1;
          n:=n-1;
          end;
        end;
    checkdiag:=tmp;
  end;
begin
  for i:=1 to 8 do
    for j:=1 to 8 do
      matearray[i,j]:=false;
  if me='W' then
    dir:=-1
  else
    dir:=1;
  tmp:= false;
  for i:=1 to 8 do
    for j:=1 to 8 do
      begin
      if ((b[i,j][1]<>me) and (b[i,j][1]<>' ')) then
        case b[i,j][2] of
          'P' : begin
                if (((i+1)<=8) and (((j+dir)<=8) and ((j+dir)>=1))) then
                  if ((b[i+1,j+dir][2]='K') and (b[i+1,j+dir][1]=me)) then
                    begin
                    matearray[i,j]:=true;
                    tmp:=true;
                    end;
                if (((i-1)>=1) and (((j+dir)<=8) and ((j+dir)>=1))) then
                  if ((b[i-1,j+dir][2]='K') and (b[i-1,j+dir][1]=me)) then
                    begin
                    matearray[i,j]:=true;
                    tmp:=true;
                    end;
                end;
          'R' : tmp:=tmp or checkhoriz(i,j);
          'Q' : begin
                tmp:=tmp or checkhoriz(i,j);
                tmp:=tmp or checkdiag(i,j);
                end;
          'K' : begin
                if (i>1) then
                  begin
                  if (j<8) then
                    if ((b[i-1,j+1][2]='K') and (b[i-1,j+1][1]=me)) then
                      begin
                      tmp:=true;
                      matearray[i,j]:=true;
                      end;
                  if ((b[i-1,j][2]='K') and (b[i-1,j][1]=me)) then
                    begin
                    tmp:=true;
                    matearray[i,j]:=true;
                    end;
                  if (j>1) then
                    if ((b[i-1,j-1][2]='K') and (b[i-1,j-1][1]=me)) then
                      begin
                      tmp:=true;
                      matearray[i,j]:=true;
                      end;
                  if tmp then
                    begin
                    tmp:=true;
                    matearray[i,j]:=true;
                    end;
                  end;
                if (i<8) then
                  begin
                  if (j<8) then
                    if ((b[i+1,j+1][2]='K') and (b[i+1,j+1][1]=me)) then
                      begin
                      tmp:=true;
                      matearray[i,j]:=true;
                      end;
                  if ((b[i+1,j][2]='K') and (b[i+1,j][1]=me)) then
                    begin
                    tmp:=true;
                    matearray[i,j]:=true;
                    end;
                  if (j>1) then
                    if ((b[i+1,j-1][2]='K') and (b[i+1,j-1][1]=me)) then
                      begin
                      tmp:=true;
                      matearray[i,j]:=true;
                      end;
                  end;
                if (j>1) then
                  begin
                  if ((b[i,j-1][2]='K') and (b[i,j-1][1]=me)) then
                    begin
                    tmp:=true;
                    matearray[i,j]:=true;
                    end;
                  end;
                if (j<8) then
                  begin
                  if ((b[i,j+1][2]='K') and (b[i,j+1][1]=me)) then
                    begin
                    tmp:=true;
                    matearray[i,j]:=true;
                    end;
                  end;
                end;
          'B' : tmp:=tmp or checkdiag(i,j);
          'N' : begin
                if ((i<8) and (j<7)) then
                  if ((b[i+1,j+2][2]='K') and (b[i+1,j+2][1]=me)) then
                    begin
                    tmp:=true;
                    matearray[i,j]:=true;
                    end;
                if ((i>1) and (j<7)) then
                  if ((b[i-1,j+2][2]='K') and (b[i-1,j+2][1]=me)) then
                    begin
                    tmp:=true;
                    matearray[i,j]:=true;
                    end;
                if ((i<8) and (j>2)) then
                  if ((b[i+1,j-2][2]='K') and (b[i+1,j-2][1]=me)) then
                    begin
                    tmp:=true;
                    matearray[i,j]:=true;
                    end;
                if ((i>1) and (j>2)) then
                  if ((b[i-1,j-2][2]='K') and (b[i-1,j-2][1]=me)) then
                    begin
                    tmp:=true;
                    matearray[i,j]:=true;
                    end;
                if ((i<7) and (j<8)) then
                  if ((b[i+2,j+1][2]='K') and (b[i+2,j+1][1]=me)) then
                    begin
                    tmp:=true;
                    matearray[i,j]:=true;
                    end;
                if ((i>2) and (j<8)) then
                  if ((b[i-2,j+1][2]='K') and (b[i-2,j+1][1]=me)) then
                    begin
                    tmp:=true;
                    matearray[i,j]:=true;
                    end;
                if ((i<7) and (j>1)) then
                  if ((b[i+2,j-1][2]='K') and (b[i+2,j-1][1]=me)) then
                    begin
                    tmp:=true;
                    matearray[i,j]:=true;
                    end;
                if ((i>2) and (j>1)) then
                  if ((b[i-2,j-1][2]='K') and (b[i-2,j-1][1]=me)) then
                    begin
                    tmp:=true;
                    matearray[i,j]:=true;
                    end;
                end;
        end; { of case }
      end;
  checkcheck:=tmp;
end; { of func checkcheck }

function domove(var b:board;
                x,y,x2,y2:integer;
                doit:boolean):boolean;
var
  me, setmovech:char;
  hoho:string[3];
  junk:boolean;
  i,j:integer;
  function CheckHoriz : boolean;
  var
    tmp,xswop,yswop:boolean;
    i,j:integer;
  begin
    tmp:=true;
    xswop:=false;
    yswop:=false;
    if (x>x2) then
      begin
      i:=x;
      x:=x2;
      x2:=i;
      xswop:=true;
      end;
    if (y>y2) then
      begin
      i:=y;
      y:=y2;
      y2:=i;
      yswop:=true;
      end;
    for i:=x to x2 do
      for j := y to y2 do
        begin
        if (b[i,j]<>'  ') then
          if ((i<>x2) and (j=y2) and (i<>x)) then
            tmp:=false
          else
            if ((j<>y2) and (i=x2) and (j<>y)) then
              tmp:=false;
        end;
    if xswop then
      begin
      i:=x;
      x:=x2;
      x2:=i;
      end;
    if yswop then
      begin
      i:=y;
      y:=y2;
      y2:=i;
      end;
    checkhoriz:=tmp;
  end; { of func CheckHoriz }
  function CheckDiag : boolean;
  var
    tmp:boolean;
    i,j,k,l:integer;
  begin
    if (x-x2)>0 then
      i:=-1
    else
      i:=1;
    if (y-y2)>0 then
      j:=-1
    else
      j:=1;
    k:=x;
    l:=y;
    tmp:=true;
    while (k<>x2) do
      begin
      k:=k+i;
      l:=l+j;
      if ((b[k,l]<>'  ') and (k<>x2)) then
        tmp:=false;
      end;
    checkdiag:=tmp;
  end; { of func CheckDiag }
begin
  me:=b[x,y][1];
  setmovech := '9';
  if ((x2<1) or (y2<1) or (x2>8) or (y2>8) or (b[x2,y2][1]=me)) then
    junk:=false
  else
    case b[x,y][2] of
      'P' : begin
            if (((y2-1=y) and ((x2+1=x) or (x2-1=x)) and (me='W')) or ((y2+1=y) and ((x2+1=x) or (x2-1=x)) and (me='B'))) then
              begin
              if ((b[x2,y2][1]<>me) and (b[x2,y2]<>'  ')) then
                begin
                junk:=true;
                hoho:=b[x2,y2];
                b[x2,y2]:=b[x,y];
                b[x,y]:='  ';
                if checkcheck(b,me) then
                  begin
                  junk:=false;
                  b[x,y]:=b[x2,y2];
                  b[x2,y2]:=hoho;
                  end
                else
                  if not doit then
                    begin
                    b[x,y]:=b[x2,y2];
                    b[x2,y2]:=hoho;
                    end
                  else
                    if (y2=8) then
                      b[x2,y2][2]:='Q';
                end
              else
                begin
                if (((me='W') and (y=5)) or ((me='B') and (y=4))) then
                  if ((b[x+1,y][2]='P') and (b[x+1,y][3]='8') and (b[x2,y2]='  ')) then
                    begin { en passant }
                    hoho:=b[x+1,y];
                    b[x+1,y]:='  ';
                    b[x2,y2]:=b[x,y];
                    b[x,y]:='  ';
                    if checkcheck(b,me) then
                      begin
                      b[x+1,y]:=hoho;
                      b[x,y]:=b[x2,y2];
                      b[x2,y2]:='  ';
                      junk:=false;
                      end
                    else
                      begin
                      junk:=true;
                      if not doit then
                        begin
                        b[x+1,y]:=hoho;
                        b[x,y]:=b[x2,y2];
                        b[x2,y2]:='  ';
                        junk:=false;
                        end;
                      end;
                    end
                  else
                    if ((b[x-1,y][2]='P') and (b[x-1,y][3]='8') and (b[x2,y2]='  ')) then
                      begin
                      hoho:=b[x-1,y];
                      b[x-1,y]:='  ';
                      b[x2,y2]:=b[x,y];
                      b[x,y]:='  ';
                      if checkcheck(b,me) then
                        begin
                        b[x-1,y]:=hoho;
                        b[x,y]:=b[x2,y2];
                        b[x2,y2]:='  ';
                        junk:=false;
                        end
                      else
                        begin
                        junk:=true;
                        if not doit then
                          begin
                          b[x-1,y]:=hoho;
                          b[x,y]:=b[x2,y2];
                          b[x2,y2]:='  ';
                          junk:=false;
                          end;
                        end;
                      end
                    else
                      junk:=false
                else
                  junk:=false;
                end;
              end
            else
              if ((y2>y) and (me='W') and (x=x2)) then
                begin
                if ((((y2-y<=2) and (y=2)) or (y2-y<=1)) and (b[x2,y2]='  ')) then
                  begin
                  if y2-y = 2 then
                    setmovech := '8';
                  junk:=true;
                  hoho:=b[x2,y2];
                  b[x2,y2]:=b[x,y];
                  b[x,y]:='  ';
                  if checkcheck(b,me) then
                    begin
                    junk:=false;
                    b[x,y]:=b[x2,y2];
                    b[x2,y2]:=hoho;
                    end
                  else
                    if not doit then
                      begin
                      b[x,y]:=b[x2,y2];
                      b[x2,y2]:=hoho;
                      end
                    else
                      if (y2=8) then
                        b[x2,y2][2]:='Q';
                  end
                else
                  junk:=false;
                end
              else
                if (((y2<y) and (me='B') and (x=x2)) and (b[x2,y2]='  ')) then
                  begin
                  if (((y-y2<=2) and (y=7)) or (y-y2<=1)) then
                    begin
                    if y-y2 = 2 then
                      setmovech := '8';
                    junk:=true;
                    hoho:=b[x2,y2];
                    b[x2,y2]:=b[x,y];
                    b[x,y]:='  ';
                    if checkcheck(b,me) then
                      begin
                      junk:=false;
                      b[x,y]:=b[x2,y2];
                      b[x2,y2]:=hoho;
                      end
                    else
                      if not doit then
                        begin
                        b[x,y]:=b[x2,y2];
                        b[x2,y2]:=hoho;
                        end
                      else
                        if (y2=1) then
                          b[x2,y2][2]:='Q';
                    end
                  else
                    junk:=false;
                  end
                else
                  junk:=false;
            end;
      'R' : if (((x=x2) and (y<>y2)) or ((y=y2) and (x<>x2))) then
              begin
              if checkhoriz then
                begin
                junk:=true;
                hoho:=b[x2,y2];
                b[x2,y2]:=b[x,y];
                b[x,y]:='  ';
                if checkcheck(b,me) then
                  begin
                  junk:=false;
                  b[x,y]:=b[x2,y2];
                  b[x2,y2]:=hoho;
                  end
                else
                  if not doit then
                    begin
                    b[x,y]:=b[x2,y2];
                    b[x2,y2]:=hoho;
                    end;
                end
              else
                junk:=false;
              end
            else
              junk:=false;
      'B' : begin
            if ((abs(x-x2)=abs(y-y2)) and (x<>x2)) then { make sure it is diagonal }
              begin
              if checkdiag then
                begin
                junk:=true;
                hoho:=b[x2,y2];
                b[x2,y2]:=b[x,y];
                b[x,y]:='  ';
                if checkcheck(b,me) then
                  begin
                  junk:=false;
                  b[x,y]:=b[x2,y2];
                  b[x2,y2]:=hoho;
                  end
                else
                  if not doit then
                    begin
                    b[x,y]:=b[x2,y2];
                    b[x2,y2]:=hoho;
                    end;
                end
              else
                junk:=false;
              end
            else
              junk:=false;
            end;
      'Q' : begin
            if ((x=x2) or (y=y2)) then
              begin
              if checkhoriz then
                begin
                hoho:=b[x2,y2];
                b[x2,y2]:=b[x,y];
                b[x,y]:='  ';
                if checkcheck(b,me) then
                  begin
                  junk:=false;
                  b[x,y]:=b[x2,y2];
                  b[x2,y2]:=hoho;
                  end
                else
                  begin
                  junk:=true;
                  if not doit then
                    begin
                    b[x,y]:=b[x2,y2];
                    b[x2,y2]:=hoho;
                    end;
                  end;
                end
              else
                junk:=false;
              end
            else
              if (abs(x-x2)=abs(y-y2)) then
                begin
                if checkdiag then
                  begin
                  hoho:=b[x2,y2];
                  b[x2,y2]:=b[x,y];
                  b[x,y]:='  ';
                  if checkcheck(b,me) then
                    begin
                    junk:=false;
                    b[x,y]:=b[x2,y2];
                    b[x2,y2]:=hoho;
                    end
                  else
                    begin
                    junk:=true;
                    if not doit then
                      begin
                      b[x,y]:=b[x2,y2];
                      b[x2,y2]:=hoho;
                      end;
                    end;
                  end
                else
                  junk:=false;
                end
              else
                junk:=false;
            end;
      'N' : begin
            if (((abs(x-x2)=1) and (abs(y-y2)=2)) or ((abs(x-x2)=2) and (abs(y-y2)=1))) then
              begin
              junk:=true;
              hoho:=b[x2,y2];
              b[x2,y2]:=b[x,y];
              b[x,y]:='  ';
              if checkcheck(b,me) then
                begin
                junk:=false;
                b[x,y]:=b[x2,y2];
                b[x2,y2]:=hoho;
                end
              else
                if not doit then
                  begin
                  b[x,y]:=b[x2,y2];
                  b[x2,y2]:=hoho;
                  end;
              end
            else
              junk:=false;
            end;
      'K' : begin
            if ((abs(x-x2)<=1) and (abs(y-y2)<=1)) then
              begin
              junk:=true;
              hoho:=b[x2,y2];
              b[x2,y2]:=b[x,y];
              b[x,y]:='  ';
              if checkcheck(b,me) then
                begin
                junk:=false;
                b[x,y]:=b[x2,y2];
                b[x2,y2]:=hoho;
                end
              else
                begin
                if not doit then
                  begin
                  b[x,y]:=b[x2,y2];
                  b[x2,y2]:=hoho;
                  end;
                end;
              end
            else
              if (b[x,y][3]='1') then
                begin { posible castle }
                if (((y=8) or (y=1)) and (abs(x-x2)=2) and (y=y2)) then
                  begin
                  i:=x2;
                  j:=y2;
                  if (x-x2<0) then
                    x2:=7
                  else
                    x2:=3;
                  if checkhoriz then
                    begin { weee ok now do we go into check doing this? }
                    junk:=false;
                    hoho:=b[x,y];
                    if (x2>x) then
                      for j:=x to x2 do
                        begin
                        b[j,y]:=hoho;
                        junk:=junk or checkcheck(b,me);
                        b[j,y]:='  ';
                        end
                    else
                      for j:=x downto x2 do
                        begin
                        b[j,y]:=hoho;
                        junk:=junk or checkcheck(b,me);
                        b[j,y]:='  ';
                        end;
                    if (junk or (not doit)) then
                      begin
                      junk:=not junk;
                      b[x,y]:=hoho;
                      end
                    else
                      begin
                      if (x<x2) then
                        j:=8
                      else
                        j:=1;
                      if b[j,y][3]<>'1' then
                        begin
                        junk:=false;
                        b[x,y]:=hoho;
                        end
                      else
                        begin
                        b[x2,y2]:=hoho;
                        b[x2+((x-x2) div abs(x-x2)),y2]:=b[j,y];
                        b[j,y]:='  ';
                        junk:=true;
                        end;
                      end;
                    end
                  else
                    junk:=false;
                  end
                else
                  junk:=false;
                end
              else
                junk:=false;
            end;
    end; { of case }
  if (junk and doit) then
    begin
    for i:=1 to 8 do
      for j:= 1 to 8 do
        if b[i,j][3] in ['9','8'] then
          b[i,j][3]:='2';
    b[x2,y2][3]:=setmovech;
    end;
  domove:=junk;
end; { of dunc domove }

function checkmate(b:board;
                   me:char) : boolean;
  var
    return:boolean;
    i,j:integer;
  function checkhoriz(x,y:integer) : boolean;
    var
      i:integer;
      dummy:boolean;
  begin
    dummy:=false;
    i:=x;
    while (i<8) do
      begin
      i:=i+1;
      if matearray[i,y] then
        dummy:=dummy or domove(b,x,y,i,y,false);
      end;
    i:=x;
    while (i>1) do
      begin
      i:=i-1;
      if matearray[i,y] then
        dummy:=dummy or domove(b,x,y,i,y,false);
      end;
    i:=y;
    while (i<8) do
      begin
      i:=i+1;
      if matearray[x,i] then
        dummy:=dummy or domove(b,x,y,x,i,false);
      end;
    i:=y;
    while (i>1) do
      begin
      i:=i-1;
      if matearray[x,i] then
        dummy:=dummy or domove(b,x,y,x,i,false);
      end;
    checkhoriz:=dummy;
  end; { of func checkhoriz }
  function checkdiag(x,y:integer) : boolean;
    var i,j:integer;
        dummy:boolean;
  begin
    dummy:=false;
    i:=x;
    j:=y;
    while ((i<8) and (j<8)) do
      begin
      i:=i+1;
      j:=j+1;
      if matearray[i,j] then
        dummy:=dummy or domove(b,x,y,i,j,false);
      end;
    i:=x;
    j:=y;
    while ((i>1) and (j<8)) do
      begin
      i:=i-1;
      j:=j+1;
      if matearray[i,j] then
        dummy:=dummy or domove(b,x,y,i,j,false);
      end;
    i:=x;
    j:=y;
    while ((i<8) and (j>1)) do
      begin
      i:=i+1;
      j:=j-1;
      if matearray[i,j] then
        dummy:=dummy or domove(b,x,y,i,j,false);
      end;
    i:=x;
    j:=y;
    while ((i>1) and (j>1)) do
      begin
      i:=i-1;
      j:=j-1;
      if matearray[i,j] then
        dummy:=dummy or domove(b,x,y,i,j,false);
      end;
    checkdiag:=dummy;
  end; { of func checkdiag }
begin
  return := false;
  for i := 1 to 8 do
    for j := 1 to 8 do
      begin
      if ((b[i,j][1]=me) and (not return)) then
        begin
        case b[i,j][2] of
          'P' : begin
                if (me='W') then
                  begin
                  return:=return or domove(b,i,j,i,j+1,false);
                  return:=return or domove(b,i,j,i,j+2,false);
                  return:=return or domove(b,i,j,i-1,j+1,false);
                  return:=return or domove(b,i,j,i+1,j+1,false);
                  end
                else
                  begin
                  return:=return or domove(b,i,j,i,j-1,false);
                  return:=return or domove(b,i,j,i,j-2,false);
                  return:=return or domove(b,i,j,i-1,j-1,false);
                  return:=return or domove(b,i,j,i+1,j-1,false);
                  end;
                end;
          'K' : begin
                return:=return or domove(b,i,j,i+1,j+1,false);
                return:=return or domove(b,i,j,i-1,j+1,false);
                return:=return or domove(b,i,j,i+1,j-1,false);
                return:=return or domove(b,i,j,i-1,j-1,false);
                return:=return or domove(b,i,j,i+1,j,false);
                return:=return or domove(b,i,j,i-1,j,false);
                return:=return or domove(b,i,j,i,j-1,false);
                return:=return or domove(b,i,j,i,j+1,false);
                end;
          'Q' : begin
                return:=return or checkdiag(i,j);
                return:=return or checkhoriz(i,j);
                end;
          'N' : begin
                return:=return or domove(b,i,j,i+2,j+1,false);
                return:=return or domove(b,i,j,i-2,j+1,false);
                return:=return or domove(b,i,j,i+2,j-1,false);
                return:=return or domove(b,i,j,i-2,j-1,false);
                return:=return or domove(b,i,j,i+1,j+2,false);
                return:=return or domove(b,i,j,i-1,j+2,false);
                return:=return or domove(b,i,j,i+1,j-2,false);
                return:=return or domove(b,i,j,i-1,j-2,false);
                end;
          'R' : return:=return or checkhoriz(i,j);
          'B' : return :=return or checkdiag(i,j);
        end; { of case }
        end;
      end;
  checkmate:=not return;
end; { of func Checkmate }

function StaleMate(b:board;
                  me:char) : boolean;
  var
    x,y:integer;
    zoop,
    nomove:boolean;
  function checkmove (b:board;
                      x,y,x2,y2:integer) : boolean;
    var tmp:string[3];
  begin
    if (x2>8) or (x2<1) or (y2<1) or (y2>8) then
      checkmove:=true
    else
      begin
      if b[x2,y2][1]<>me then
        begin
        tmp:=b[x2,y2];
        b[x2,y2]:=b[x,y];
        b[x,y]:='  ';
        if not checkcheck(b,me) then
          checkmove:=false
        else
          checkmove:=true;
        b[x,y]:=b[x2,y2];
        b[x2,y2]:=tmp;
        end
      else
        checkmove:=true;
      end;
  end; { of funcboard }
  function checkhoriz(x,y:integer):boolean;
    var
      fish:boolean;
      x2,y2:integer;
  begin
    fish:=false;
    if (x<8) and (b[x+1,y][1]<>me) then
      for x2:=x to 8 do
        fish:=fish or domove(b,x,y,x2,y,false);
    if (x>1) and (b[x-1,y][1]<>me) then
      for x2:=x to 1 do
        fish:=fish or domove(b,x,y,x2,y,false);
    if (y<8) and (b[x,y+1][1]<>me) then
      for y2:=y to 8 do
        fish:=fish or domove(b,x,y,x,y2,false);
    if (y>1) and (b[x,y-1][1]<>me) then
      for y2:=y to 1 do
        fish:=fish or domove(b,x,y,x,y2,false);
    checkhoriz:=fish;
  end; { of checkhoriz }
  function checkdiag(x,y:integer):boolean;
    var
      fish:boolean;
      x2,y2:integer;
  begin
    fish:=false;
    x2:=x;
    y2:=y;
    if (x>1) and (y>1) and (b[x-1,y-1][1]<>me) then
      while (x2>1) and (x2<8) and (y2>1) and (y2<8) do
        begin
        fish:=fish or domove(b,x,y,x2,y2,false);
        x2:=x2-1;
        y2:=y2-1;
        end;
    x2:=x;
    y2:=y;
    if (x<8) and (y>1) and (b[x+1,y-1][1]<>me) then
      while (x2>1) and (x2<8) and (y2>1) and (y2<8) do
        begin
        fish:=fish or domove(b,x,y,x2,y2,false);
        x2:=x2+1;
        y2:=y2-1;
        end;
    x2:=x;
    y2:=y;
    if (x>1) and (y<8) and (b[x-1,y+1][1]<>me) then
      while (x2>1) and (x2<8) and (y2>1) and (y2<8) do
        begin
        fish:=fish or domove(b,x,y,x2,y2,false);
        x2:=x2-1;
        y2:=y2+1;
        end;
    x2:=x;
    y2:=y;
    if (x<8) and (y<8) and (b[x+1,y+1][1]<>me) then
      while (x2>1) and (x2<8) and (y2>1) and (y2<8) do
        begin
        fish:=fish or domove(b,x,y,x2,y2,false);
        x2:=x2+1;
        y2:=y2+1;
        end;
    checkdiag:=fish;
  end; { of checkdiag }
begin
  zoop := true;
  if not checkcheck(b,me) then
    begin
    for x := 1 to 8 do
      for y := 1 to 8 do
        if (b[x,y][1]=me) and (b[x,y][2]='K') then
          begin
          zoop:=checkmove(b,x,y,x+1,y+1);
          zoop:=zoop and checkmove(b,x,y,x+1,y+1);
          zoop:=zoop and checkmove(b,x,y,x,y+1);
          zoop:=zoop and checkmove(b,x,y,x+1,y);
          zoop:=zoop and checkmove(b,x,y,x-1,y-1);
          zoop:=zoop and checkmove(b,x,y,x+1,y-1);
          zoop:=zoop and checkmove(b,x,y,x-1,y+1);
          zoop:=zoop and checkmove(b,x,y,x-1,y);
          zoop:=zoop and checkmove(b,x,y,x,y-1);
          end;
    if zoop then
      for x:=1 to 8 do
        for y:=1 to 8 do
          begin
          if zoop then
            if b[x,y][1]=me then
              case b[x,y][2] of
                'P' : begin
                      if me='W' then
                        begin
                        zoop := zoop and not domove(b,x,y,x,y+1,false);
                        zoop := zoop and not domove(b,x,y,x+1,y+1,false);
                        zoop := zoop and not domove(b,x,y,x-1,y+1,false);
                        end
                      else
                        begin
                        zoop := zoop and not domove(b,x,y,x,y-1,false);
                        zoop := zoop and not domove(b,x,y,x+1,y-1,false);
                        zoop := zoop and not domove(b,x,y,x-1,y-1,false);
                        end;
                      end;
                'R' : begin
                      zoop := zoop and not checkhoriz(x,y);
                      end;
                'B' : begin
                      zoop := zoop and not checkdiag(x,y);
                      end;
                'Q' : begin
                      zoop := zoop and not checkdiag(x,y);
                      zoop := zoop and not checkhoriz(x,y);
                      end;
                'N' : begin
                      zoop := zoop and not domove(b,x,y,x+1,y+2,false);
                      zoop := zoop and not domove(b,x,y,x-1,y+2,false);
                      zoop := zoop and not domove(b,x,y,x+1,y-2,false);
                      zoop := zoop and not domove(b,x,y,x-1,y-2,false);
                      zoop := zoop and not domove(b,x,y,x+2,y+1,false);
                      zoop := zoop and not domove(b,x,y,x-2,y+1,false);
                      zoop := zoop and not domove(b,x,y,x+2,y-1,false);
                      zoop := zoop and not domove(b,x,y,x-2,y-1,false);
                      end;
              end; { of case }
          end;
    end
  else
    zoop:=false;
  stalemate:=zoop;
end; { of func Stalemate }

end. { of unit chessmov }
