unit chesutil;
{
   Copyleft Message from your Sponsor:

        This program is utterly copyright (c) David Bennett, 1990
        and WhelkSoft, his 'software label', also 1990.
        Except for the bits that are copyright Borland Software.
        The actual code is distributed according to a vaguely
        Free Software Foundation license.  That is:

        You can copy the source and binaries.  You can distribute
        them to everyone you know.  However:

        1. You MAY NOT charge for the program, except for a reasonable
        cost of media and transportation.

        2. The original program was written by David Bennett and
        original authorship still resides with him.  So, you must
        distribute code still having his copyright messages.

        3. We strongly recommend that any site having or using this
        software should have the original sourcecode available to
        anyone who wants it.  Further development of computing in
        general may depend on sharing expertise and code.

        4. The above conditions should apply to any further
        development of this program.

        Please send the University Computer Club (oh, and David
        Bennett) some sort of postcard from where you are and how
        much you hate Whelk Chess ... we like to have our egos stroked!

}

interface

uses
  chestype;

function strupr(s:string) : string;
procedure NoPoints(b:board;
                   var black,white : integer);
procedure DrawBoard(bd:board;
                   me:char;
                   nomoves:integer;
                   p1,p2:string);
function PlayerName(i:integer) : string;
function score(i:integer) : integer;
function findplayer(s:string):integer;
procedure UnpackGame(var b:board;
                         g:integer;
                     var m:integer);
procedure UnpackGame2(var b:board;
                        b1:boardrec);
procedure PackGame(b:board;
                   g:integer;
                   m:integer;
                   line1,
                   line2:string);
procedure IWon(i:integer;
               loser:integer);
procedure Idraw(i:integer;
               loser:integer);
procedure finishgame(i:integer);
procedure unfinishgame(i:integer);

implementation

uses
  crt,
  fossil,
  fosout;

function strupr(s:string) : string;
  var
    s2:string;
    i:integer;
begin
  s2:='';
  for i := 1 to length(s) do
    s2:=s2+upcase(s[i]);
  strupr:=s2;
end; { of func strupr }

procedure NoPoints(b:board;
                   var black,white : integer);
  var
    i,j: integer;
  function pointvalue(c:char):integer;
  begin
    case c of
      'P' : pointvalue:=1;
      'B','N'
          : pointvalue:=3;
      'R' : pointvalue:=5;
      'Q' : pointvalue:=10;
    else
      pointvalue:=0;
    end; { of case }
  end;
begin
  black:=0;
  white:=0;
  for i:=1 to 8 do
    for j:= 1 to 8 do
      begin
      if b[i,j][1]='B' then
        black:=black+pointvalue(b[i,j][2]);
      if b[i,j][1]='W' then
        white:=white+pointvalue(b[i,j][2]);
      end;
end; { of proc NoPoints }

procedure DrawBoard(bd:board;
                   me:char;
                   nomoves:integer;
                   p1,p2:string);
  var
    c,c2:char;
    i,j:integer;
    s,s2,s3,s4,s5:string;
  function bval(x,y:integer):string;
  begin
    if me='W' then
      bval:=bd[x,y]
    else
      bval:=bd[9-x,9-y];
  end; { of func bval }
begin
  clrscr;
  Nopoints(bd,i,j);
  str(i,s3);
  str(j,s2);
  str(nomoves,s4);
  colour(yellow,black);
  writestr('   ');
  for i := 1 to 8 do
    writestr(' '+chr(64+i)+'  ');
  textcolor(red);
  writestrln('');
  if ansion then
    writestr('  ')
  else
    writestr('  +');
  for i := 1 to 8 do
    if ansion then
      writestr('')
    else
      writestr('----');
  if ansion then
    writestrln('')
  else
    writestrln('+');
  for i :=  1 to 9 do
    begin
    colour(red,black);
    if ansion then
      writestr('  ')
    else
      if (i<>9) then
        writestr('  |');
    textcolor(lightgray);
    for j := 1 to 8 do
      begin
      if ansion then
        if (((j+i) mod 2)=1) then
          if (i<>9) then
            writestr('')
          else
            writestr('    ')
        else
          begin
          if (i<>1) then
            writestr('')
          else
            writestr('    ');
          end
       else
         begin
         if (i<>9) then
           begin
           s5:=bval(j,9-i);
           if (((j+i) mod 2)=1) then
             if s5[1]='W' then
               writestr(':')
             else
               writestr(':-')
           else
             if s5[1]='W' then
               writestr(' ')
             else
               writestr('  ');
           if s5[1]=' ' then
             if (((j+i) mod 2)=1) then
               writestr('-')
             else
               writestr(' ')
           else
             writestr(s5[1]);
           if (((j+i) mod 2)=1) then
             if s5[1]='W' then
               writestr('-:')
             else
               writestr(':')
           else
             if s5[1]='W' then
               writestr('  ')
             else
               writestr(' ');
           end;
         end;
      end;
   colour(red,black);
   if (not ansion) and (i<>9) then
     writestr('|');
   if (ansion) then
     writestr('');
   textcolor(lightgray);
   case i of
     1  : begin
          textcolor(yellow);
          Writestr('                Whelk Chess');
          textcolor(lightgray);
          end;
     3  : if me='B' then
            begin
            Writestr('             Black    :*'+s3);
            textcolor(yellow);
            writestr(' '+copy(p2,1,15));
            textcolor(lightgray);
            end
          else
            Writestr('             Black    : '+s3+' '+copy(p2,1,15));
     4  : Writestr('             Move No  : '+s4);
     5  : begin
          textcolor(red);
          Writestr('                  Help');
          end;
     7  : writestr('             Queen (Q) : 10');
     8  : writestr('             Knight(N) : 3');
     9  : if ansion then
            writestr('             Pawn  (P) : 1');
   else
     Writestr('');
   end; { of case }
   if (not ansion and (i<>9)) then
     writestrln('');
   if (ansion) then
     writestrln('');
   if (i<>9) then
     begin
     textcolor(yellow);
     str(9-i,s);
     writestr(s);
     textcolor(red);
     if ansion then
       writestr(' ')
     else
       writestr(' |');
     colour(lightgray,black);
     for j := 1 to 8 do
       begin
       s5:=bval(j,9-i);
       if ((i+j) mod 2)=0 then
         if (s5[1]='B') and (not ansion) then
           writestr('  ')
         else
           writestr(' ')
       else
         if ansion then
           begin
           textbackground(lightgray);
           writestr(' ');
           end
         else
           if s5[1]='B' then
             writestr(':-')
           else
             writestr(':');
       if (s5[1]='W') then
         textcolor(white)
       else
         if (s5[1]='B') and (((i+j) mod 2)=0) then
           textcolor(lightgray)
         else
           textcolor(black);
       if ((s5<>'  ') or ansion or (((i+j) mod 2)=0)) then
         if ansion then
           if (s5[3] in ['9','8']) and (s5[1] in ['B','W']) then
             begin
             if (i+j) mod 2=0 then
               begin
               textbackground(lightgray);
               if (s5[1]='B') then
                 textcolor(black);
               end
             else
               begin
               if s5[1]='B' then
                 textcolor(lightgray);
               textbackground(black);
               end;
             writestr(copy(s5,1,2));
             if (i+j) mod 2=0 then
               textbackground(black)
             else
               textbackground(lightgray)
             end
           else
             writestr(copy(s5,1,2))
         else
           writestr(s5[2])
       else
         writestr('-');
       if ((i+j) mod 2)=0 then
         if ansion then
           writestr(' ')
         else
           if s5[1]='B' then
             writestr(' ')
           else
             writestr('  ')
       else
         if ansion then
           begin
           writestr(' ');
           textbackground(black)
           end
         else
           if s5[1]='B' then
             writestr(':')
           else
             writestr('-:');
       end;
     colour(red,black);
     if (not ansion) and (i<>9) then
       writestr('|');
     if (ansion and (i<>9)) then
       writestr('');
     textcolor(lightgray);
     case i of
       1  : begin
            textcolor(red);
            Writestr('             by David Bennett');
            textcolor(lightgray);
            end;
       2  : Writestr('');
       3  : if me='W' then
              begin
              Writestr('             White    :*'+s2);
              textcolor(yellow);
              writestr(' '+copy(p1,1,15));
              textcolor(lightgray);
              end
            else
              Writestr('             White    : '+s2+' '+copy(p1,1,15));
       5  : Writestr('              Esc Quit.');
       6  : begin
            textcolor(red);
            writestr('                Points.');
            end;
       7  : writestr('             Rook  (R) : 5');
       8  : writestr('             Bishop(B) : 3');
     else
       Writestr('');
     end; { of case }
     if (i<>9) then
       writestrln('');
     end;
   end;
   textcolor(red);
   if ansion then
     writestr('  ')
   else
     writestr('  +');
   for j:=1 to 8 do
     if ansion then
       writestr('')
     else
       writestr('----');
   if ansion then
     writestrln('')
   else
     writestrln('+             Pawn  (P) : 1');
   textcolor(lightgray);
end; { of proc DrawBoard }

function PlayerName(i:integer) : string;
var
  f:file of player;
  p:player;
begin
  if i=-1 then
    playername:='No One'
  else
    begin
    assign(f,'CPLAYER.DAT');
    reset(f);
    seek(f,i);
    read(f,p);
    close(f);
    playername:=p.name;
    end;
end; { of Proc PlayerName }

function findplayer(s:string):integer;
  var
    f:file of player;
    p:player;
begin
  assign(f,'PLAYER.DAT');
  reset(f);
  findplayer:=-1;
  while not eof(f) do
    begin
    read(f,p);
    if strupr(p.name)=strupr(s) then
      findplayer:=filepos(f)-1;
    end;
 close(f);
end; { of proc findplayer }

function score(i:integer) : integer;
  var
    f:file of player;
    p:player;
begin
  assign(f,'PLAYER.DAT');
  reset(f);
  seek(f,i);
  read(f,p);
  score:=p.gameswon;
  close(f);
end; { of func score }

procedure UnpackGame(var b:board;
                         g:integer;
                     var m:integer);
var i,j:integer;
    k:word;
    f:file of boardrec;
    b1:boardrec;
begin
  assign(f,'CGAMES.DAT');
  reset(f);
  seek(f,g);
  read(f,b1);
  close(f);
  for i:= 1 to 8 do
    for j := 1 to 8 do
      begin
      if (b1.board[i,j]=0) then
        b[i,j]:='  '
      else
        begin
        if (b1.board[i,j] and $80)=0 then
          b[i,j]:='W'
        else
          b[i,j]:='B';
        case (b1.board[i,j] and $07) of
          1 : b[i,j]:=b[i,j]+'P';
          2 : b[i,j]:=b[i,j]+'R';
          3 : b[i,j]:=b[i,j]+'B';
          4 : b[i,j]:=b[i,j]+'N';
          5 : b[i,j]:=b[i,j]+'K';
          6 : b[i,j]:=b[i,j]+'Q';
        end; { of case }
        b[i,j]:=b[i,j]+chr(((b1.board[i,j] and $78) shr 3)+ ord('0'))
        end;
      end;
  m:=b1.nomoves;
end; { of proc UnpackGame }

procedure UnpackGame2(var b:board;
                        b1:boardrec);
var i,j:integer;
    k:word;
begin
  for i:= 1 to 8 do
    for j := 1 to 8 do
      begin
      if (b1.board[i,j]=0) then
        b[i,j]:='  '
      else
        begin
        if (b1.board[i,j] and $80)=0 then
          b[i,j]:='W'
        else
          b[i,j]:='B';
        case (b1.board[i,j] and $07) of
          1 : b[i,j]:=b[i,j]+'P';
          2 : b[i,j]:=b[i,j]+'R';
          3 : b[i,j]:=b[i,j]+'B';
          4 : b[i,j]:=b[i,j]+'N';
          5 : b[i,j]:=b[i,j]+'K';
          6 : b[i,j]:=b[i,j]+'Q';
        end; { of case }
        b[i,j]:=b[i,j]+chr(((b1.board[i,j] and $78) shr 3)+ ord('0'))
        end;
      end;
end; { of proc UnpackGame }

procedure PackGame(b:board;
                   g:integer;
                   m:integer;
                   line1,
                   line2:string);
var
  i,j:integer;
  k:word;
  f:file of boardrec;
  b1:boardrec;
begin
  assign(f,'CGAMES.DAT');
  reset(f);
  seek(f,g);
  read(f,b1);
  for i:= 1 to 8 do
    for j:= 1 to 8 do
      begin
      b1.board[i,j]:=0;
      case b[i,j][2] of
        'P' : b1.board[i,j]:=1;
        'R' : b1.board[i,j]:=2;
        'N' : b1.board[i,j]:=4;
        'B' : b1.board[i,j]:=3;
        'K' : b1.board[i,j]:=5;
        'Q' : b1.board[i,j]:=6;
      end;
      if b[i,j][1]='B' then
        b1.board[i,j]:=b1.board[i,j] or $80;
      if b[i,j]<>'  ' then
        b1.board[i,j]:=b1.board[i,j] or ((ord(b[i,j][3])-ord('0')) shl 3);
      end;
  b1.line1:=line1;
  b1.line2:=line2;
  b1.nomoves:=m;
  seek(f,g);
  write(f,b1);
  close(f);
end; { of proc packgame }

procedure IWon(i:integer;
               loser:integer);
  var
    p1,p2:player;
    score:integer;
    f:file of player;
begin
  assign(f,'CPLAYER.DAT');
  reset(f);
  seek(f,loser);
  read(f,p2);
  seek(f,i);
  read(f,p1);
  p1.gamesplayed:=p1.gamesplayed+1;
  p2.gamesplayed:=p2.gamesplayed+1;
  score := (p1.gameswon+p2.gameswon+50) div 2;
  if score>p1.gameswon then
    p1.gameswon:=score;
  score := (p1.gameswon+p2.gameswon-50) div 2;
  if (score>0) and (score<p2.gameswon) then
    p2.gameswon:=score;
  seek(f,i);
  write(f,p1);
  seek(f,loser);
  write(f,p2);
  close(f);
end; { of IWon }

procedure Idraw(i:integer;
               loser:integer);
  var
    p1,p2:player;
    score:integer;
    f:file of player;
begin
  assign(f,'CPLAYER.DAT');
  reset(f);
  seek(f,loser);
  read(f,p2);
  seek(f,i);
  read(f,p1);
  p1.gamesplayed:=p1.gamesplayed+1;
  p2.gamesplayed:=p2.gamesplayed+1;
  score := (p1.gameswon+p2.gameswon) div 2;
  p1.gameswon:=score;
  p2.gameswon:=score;
  seek(f,i);
  write(f,p1);
  seek(f,loser);
  write(f,p2);
  close(f);
end; { of IWon }

procedure finishgame(i:integer);
  var
    f:file of boardrec;
    b1:boardrec;
begin
  assign(f,'CGAMES.DAT');
  reset(f);
  seek(f,i);
  read(f,b1);
  b1.timefin:=getthetime;
  seek(f,i);
  write(f,b1);
  close(f);
end; { of proc finishgame }

procedure unfinishgame(i:integer);
  var
    f:file of boardrec;
    b1:boardrec;
begin
  assign(f,'CGAMES.DAT');
  reset(f);
  seek(f,i);
  read(f,b1);
  b1.timefin:=0;
  seek(f,i);
  write(f,b1);
  close(f);
end; { of proc unfinishgame }

end.
