unit readinfo;
{
   Copyleft Message from your Sponsor:

        This program is utterly copyright (c) David Bennett, 1990
        and WhelkSoft, his 'software label', also 1990.
        Except for the bits that are copyright Borland Software.
        The actual code is distributed according to a vaguely
        Free Software Foundation license.  That is:

        You can copy the source and binaries.  You can distribute
        them to everyone you know.  However:

        1. You MAY NOT charge for the program, except for a reasonable
        cost of media and transportation.

        2. The original program was written by David Bennett and
        original authorship still resides with him.  So, you must
        distribute code still having his copyright messages.

        3. We strongly recommend that any site having or using this
        software should have the original sourcecode available to
        anyone who wants it.  Further development of computing in
        general may depend on sharing expertise and code.

        4. The above conditions should apply to any further
        development of this program.

        Please send the University Computer Club (oh, and David
        Bennett) some sort of postcard from where you are and how
        much you hate Whelk Chess ... we like to have our egos stroked!

}
{ this unit contains all the routines for reading info from the different
  format info files ie DORINFO1.DEF, PCBOARD.SYS etc }

interface

uses
  fossil,
  fosout;

var
  securitylevel,
  sysopsec : word;
  baudrate : integer;
  Sysopname,
  username,
  BBSName,
  UserAddress : string;

function ReadDorinfo(s:string) : boolean;
procedure CheckParameters;
function Readcontrolfile(filnam:string) : boolean;

implementation

type
  chset = set of char;

function readcontrolfile(filnam:string) : boolean;
  var
    f:text;
    s:string;
    dorinfo,
    bname:string;
    fish:integer;
  function stripstring(s:string;
                       cset:chset):string;
    var
      i:integer;
  begin
  i:=1;
  while (i<length(s)) do
    begin
    if s[i] in cset then
      s:=copy(s,1,i-1);
    i:=i+1;
    end;
  stripstring:=s;
  end; { of stripstring }
begin
  sysopname :='';
  if (filnam = '') then
    begin
    readcontrolfile := false;
    exit;
    end;
  assign(f,filnam);
  {$i-}
  reset(f);
  {$I+}
  if (ioresult<>0) then
    begin
    readcontrolfile:=false;
    exit;
    end;
  { first line contains the name of the BBS }
  readln(f,s);
  { but ignore all characters after any ';' if two in a row turn into 1 }
  Bname:=stripstring(s,[';']);
  { second line contains path to dorinfo1.def file }
  readln(f,s);
  dorinfo:=stripstring(s,[' ',';']);
  if not readdorinfo(dorinfo) then
    begin
    close(f);
    readcontrolfile:=false;
    exit;
    end;
  bbsname:=bname;
  { third line contains the sysop security level }
  readln(f,s);
  s:=stripstring(s,[' ',';']);
  val(s,sysopsec,fish);
  close(f);
  readcontrolfile:=true;
end; { of readcontrol file }

function ProcessUser(s:string):string;
  var
    i:integer;
    b:boolean;
begin
  b:=true;
  i:=1;
  repeat
    if b then
      begin
      b:=false;
      s[i]:=upcase(s[i]);
      end
    else
      begin
      if (s[i] in ['A'..'Z']) then
        begin
        s[i]:=chr(ord(s[i])+32);
        end;
      end;
    if (s[i]=' ') then
      b:=true;
    i:=i+1;
  until i>length(s);
  processuser:= s;
end; { of func processUser }

function ReadDorinfo(s:string) : boolean;
  var f   : text;
      s1  : string;
      j,k : integer;
begin
 if s[length(s)]<>'\' then
   s:=s+'\';
 assign(f,s+'Dorinfo1.def');
 {$I-}
 reset(f);
 {$I+}
 if (IOResult<>0) then
   begin
   ReadDorinfo:=false;
   exit;
   end;
 readln(f,BBSName);     { BBS Name }
 if (sysopname='') then
   begin
   readln(f,SysopName);   { Sysop FName }
   readln(f,s1);          { Sysop Last Name }
   SysopName := ProcessUser(SysopName + ' ' + s1);
   end
 else
   begin
   readln(f,s1);
   readln(f,s1);
   end;
 readln(f,s1);          { Com port }
 if (copy(s1,1,3)<>'COM') then
   begin
   ReadDorInfo:=false;
   close(f);
   exit;
   end;
 val(copy(s1,4,1),portno,j);
 readln(f,s1);          { Port settings ie Baud,Partity etc }
 val(copy(s1,1,4),baudrate,j);    { But we only want baud assume parity 8,n,1 }
 readln(f,s1);          { some other value might be baud again }
 readln(f,UserName);    { Users first name }
 readln(f,s1);          { Users Last name }
 UserName := ProcessUser(UserName + ' ' + s1);
 readln(f,UserAddress); { Address of user }
 readln(f,s1);          { Ansi on or off }
 if (s1='1') then
   ansion:=true
 else
   ansion:=false;
 readln(f,s1);          { Security Level }
 val(s1,securitylevel,j);
 readln(f,s1);          { Remaining Time }
 val(s1,j,k);
 setkickoff(j);
 close(f);
 ReadDorinfo:=true;
end; { of readdorinfo }

procedure CheckParameters;
var
  i,j,time :integer;
  s:string;
  sec,sec100 : word;
begin
  Baudrate:=0;
  time := 300;
  for i:=1 to paramcount do
    begin
    s:=paramstr(i);
    if (s[1]='-') then
      case upcase(s[2]) of
        'N' : begin
              infilenam := Copy(s,3,length(s));
              end;
        'P' : begin
              val(Copy(s,3,10),PortNo,j);
              end;
        'B' : begin
              val(copy(s,3,10),BaudRate,j);
              end;
        'T' : begin
              val(copy(s,3,10),time,j);
              end;
      end;
    end;
  setkickoff(time);
  if ((portno<>0) and (Baudrate<>0)) then
    begin { initailise fossil driver }
    initfossil(portno);
    Setbaud(portno,baudrate);
    end;
end; { of proc CheckParameters }

begin
end.
