Program StarInit;

{Initializer program for StarClash by Elihu Feustel
 I recommend you play at least one whole game before changing
 the starting values. These have been playtested for about 8
 months, and lead to a very exciting but strategic game.}

{Any ideas, improvements, upgrade requests, or donations, send to:
 Elihu Feustel
 Box 1421
 Rose Hulman Institute of Technology
 Terre Haute, IN 47813

 or call StrongPoint Alpha
         812-877-4416
         3-12 baud (24 is too noisy)
                                    }

Const
      deathlength = 4;
      startmoney = 30;
      starttech = 2;
      atmod = 0.3;  {attacker damage ratio}
      dfmod = 0.45; {defender damage ratio}
      techinc =0.25; {.25 raises tech every 4 days, .2 raises every 5,...}
      allow_alias = 0; {0 is true, 1 is false}

Type field=Array[1..400,1..19]of byte;


Var fila            :text;
    filc,filb       :text;
    fild            :file of field;
    Verify          :char;
    l1,l2,rn        :integer;
    blif,diff       :string[19];
    dorf            :field;
    at1,df1,cm1,or1,price :Array[1..15]of integer;
    Bass            :Array[1..4] of string[25];
    Plan            :Array[1..20] of string[20];
    Stuff           :Array[1..19] of string[25];
    gt,gd           :String[50];

    file1,file2,file3,file4,
    file5,file6,file7,file8,file9   :string[66];

Begin

Writeln('Running this program will destroy the previous game. Proceed?');
Readln(verify);
if verify ='y' then
  begin
        file1:= 'starsect.dat';
        file2:= 'stardate.dat';
        file3:= 'starplay.dat';
        file4:= 'starnews.txt';
        file5:= 'starolds.txt';
        file6:= 'starvars.dat';
        file7:= 'starmenu.dat';
        file8:= 'starhigh.txt';
        file9:= 'starmsgs.txt';
    Assign(fila,file4);
    Rewrite(fila);
    Writeln(fila,'StarClash initiated.');
    Close(fila);
    Assign(fila,file5);
    Rewrite(fila);
    Writeln(fila,'blorf');
    Assign(fild,file1);
    ReWrite(fild);
    blif:='';
    for l1:=1 to 400 do
    for l2:=1 to 19 do
      begin
        dorf[l1,l2]:=0;
      end;

      {Federation set up}

        for l1:=1 to 5 do
      for l2:=1 to 5 do
        begin
          dorf[l1*20+280+15+l2,2]:=1;
          dorf[l1*20+280+15+l2,19]:=1;
        end;
    dorf[399,16]:=1;     {planet 1 for Feds}
    dorf[399,7]:=1;
    dorf[380,7]:=1;
    dorf[380,16]:=1;     {planet 2 for Feds}
    dorf[400,1]:=10;
    dorf[400,2]:=20;
    dorf[400,3]:=10;
    dorf[400,7]:=1;
    dorf[400,15]:=2;
    dorf[400,16]:=2;     {home planet Feds}
    dorf[400,19]:=1;

    {The Federation's Power can be adjusted by playing with the numbers
     on the Fed's planets. dorf[400,16] is the home planet, and should
     always be at least one. None of them should be higher than 4, or bad
     things happen, as the program isn't designed to support planets that
     big.}

    randomize;
    for l1:=1 to 40 do
      begin
        repeat
          rn:=random(398)+1;
        until dorf[rn,16]=0;
          dorf[rn,16]:=1;
      end;
    write(fild,dorf);
    close(fild);

    {sectors inited. Next comes players.}

    Assign(filc,file3);
    rewrite(filc);
    Writeln(filc,'Neutral      ');
    Writeln(filc,'Neutral      ');
    Writeln(filc,0);
    Writeln(filc,10);
    Writeln(filc,-1);
    Writeln(filc,2);
    Writeln(filc,'Federation #0');
    Writeln(filc,'Federation #0');
    Writeln(filc,0);
    Writeln(filc,10);
    Writeln(filc,100);
    Writeln(filc,4);  {Federation starting Tech Level}

    {The Fed's level is another way of determining their strength. This should
     always be between 2 and 9}

    Close(filc);

    {Players inited. Next comes stardate.}

    Assign(filb,file2);
    rewrite(filb);
    writeln(filb,0);
    Close(filb);

    {Stardate done. Next comes message base init.}
    Assign(fila,file9);
    Rewrite(fila);
    Writeln(fila,'SysOp inited the galaxy.');
    Writeln(fila,1);
    Writeln(fila,1);
    Close(fila);
  end;

  bass[1]:= 'Space dock';
  bass[2]:= 'Base station';
  bass[3]:= 'Battle station';
  bass[4]:= 'StarBase';

  stuff[1]:='Destroyer';        Price[1]:=15; at1[1]:=5;  Df1[1]:=4; cm1[1]:=7;
  stuff[2]:='Attack shuttle';   Price[2]:=4;  at1[2]:=1;  Df1[2]:=1; cm1[2]:=1;
  stuff[3]:='Heavy Cruiser';    price[3]:=40; at1[3]:=8;  Df1[3]:=8; cm1[3]:=9;
  stuff[4]:='Bomber squadron';  Price[4]:=7;  at1[4]:=3;  Df1[4]:=1; cm1[4]:=3;
  stuff[5]:='Fighter squadron'; Price[5]:=7;  at1[5]:=1;  Df1[5]:=1; cm1[5]:=3;
  stuff[6]:='Dreadnought';      Price[6]:=100; at1[6]:=12; Df1[6]:=14;cm1[6]:=12;
  stuff[7]:='Mine Ship';        Price[7]:=40; at1[7]:=2;  Df1[7]:=6; cm1[7]:=8;
  stuff[8]:='Destroyer X+';     Price[8]:=40; at1[8]:=12; Df1[8]:=9; cm1[8]:=8;
  stuff[9]:='Heavy Cruiser X+'; Price[9]:=80; at1[9]:=16; Df1[9]:=13;cm1[9]:=10;
  stuff[10]:='Crippled Destroyer';       at1[10]:=2;  Df1[10]:=2;    cm1[10]:=7;
  stuff[11]:='Crippled Cruiser';         at1[11]:=4;  Df1[11]:=4;    cm1[11]:=9;
  stuff[12]:='Crippled Dreadnought';     at1[12]:=6;  Df1[12]:=7;    cm1[12]:=12;
  stuff[13]:='Crippled Destroyer X+';    at1[13]:=6;  Df1[13]:=4;    cm1[13]:=8;
  stuff[14]:='Crippled Cruiser X+';      at1[14]:=8;  Df1[14]:=6;    cm1[14]:=10;
  stuff[15]:='Base ';                    at1[15]:=15;  Df1[15]:=8;   cm1[15]:=12;
  stuff[16]:='Planet';
  stuff[17]:='Irregularity';
  stuff[18]:='Mine density';
  stuff[19]:='Territory';

Price[10]:=4; Price[11]:=10; Price[12]:=25; Price[13]:=10; Price[14]:=20;


  plan[1]:='Habitable planet';
  plan[2]:='Minor planet';
  plan[3]:='Major planet';
  plan[4]:='Key planet/system';

  or1[1]:=9;   or1[2]:=6;   or1[3]:=8;   or1[4]:=3;   or1[5]:=1;
  or1[6]:=4;   or1[7]:=7;   or1[8]:=5;   or1[9]:=2;   or1[10]:=14;
  or1[11]:=12; or1[12]:=11; or1[13]:=13; or1[14]:=10; or1[15]:=15;

Assign(fila,file6);
Rewrite(fila);
For l1:=1 to 15 do
  begin
    Writeln(fila,at1[l1]);
    Writeln(fila,df1[l1]);
    Writeln(fila,cm1[l1]);
    Writeln(fila,or1[l1]);
    Writeln(fila,price[l1]);
  end;
For l1:=1 to 19 do Writeln(fila,stuff[l1]);
For l1:=1 to 4 do
  begin
    Writeln(fila,bass[l1]);
    Writeln(fila,plan[l1]);
  end;
Writeln(fila,deathlength);
Writeln(fila,startmoney);
Writeln(fila,starttech);
Writeln(fila,atmod);
Writeln(fila,dfmod);
Writeln(fila,techinc);
Writeln(fila,allow_alias);
Close(fila);
Assign(fila,file7);
Rewrite(fila);
Writeln(fila,'Your Options: A)ctivate mines, B)uild, C)olonize, D)ock, E)ntire map,');
Writeln(fila,'F)und transfer, G)arrison and move, H)elp, I)nventory, L)ocal info, M)ove,');
Writeln(fila,'N)ews, O)utpost construction, P)robe sector, Q)uit, R)&D, S)can, T)ransfer to');
Writeln(fila,'sector, U)noccupy sector, W)rite mail, X)pert mode, Y)our totals, ?)list menu.');
Close(fila);
Assign(fila,file8);
Rewrite(fila);
Writeln(fila,'Nobody is alive.');
end.